#v1.1
try:
    from vcCommand import * 
    import vcMatrix, vcVector
    import csv
    from vcScript import *
except:
    print "Modules not found"

cmd = getCommand()
app = cmd.Application
sim = cmd.Simulation

def OnStart():
  global path, import_option, btn_click
  global Property_Name, Property_Type,VCProperty_Type,Property_Value,Property_Rebuild

  path = cmd.createProperty(VC_URI, 'Select CSV')
  import_option = cmd.createProperty(VC_STRING, 'Import as', VC_PROPERTY_STEP)
  import_option.StepValues = ['ImportPropertyList']
  import_option.Value = 'ImportPropertyList'
  btn_click = cmd.createProperty(VC_BUTTON, 'Import')
  executeInActionPanel()
  btn_click.OnChanged = ImportFromCSV


def addProperty(component_name, Property_name, Property_info):
    global Property_Name, Property_Type,VCProperty_Type,Property_Value,Property_Rebuild,Property_UpdateSimulation
    comp = app.CurrentContext
    if not comp:
        return
    # 为组件添加信号
    Foo = comp.findBehaviour(Property_Name)
    if not Foo:
        Foo=comp.createBehaviour(VCProperty_Type,Property_Name)
    Foo.Value = Property_Value
    Foo.Rebuild = Property_Rebuild
    Foo.UpdateSimulation = Property_UpdateSimulation

    print("Property added to component .")

def ImportFromCSV(prop):
  '''
  Import from cvs file row format\n
  Name,Type,Value,Rebuild,Update simulation
  Property1,Real,5.23,TRUE,FALSE
  Property2,Integer,11,FALSE,TRUE
  Property3,Boolean,TRUE,TRUE,FALSE
  Property4,String,A001,FALSE,TRUE
  '''
  global Property_Name, Property_Type,VCProperty_Type,Property_Value,Property_Rebuild,Property_UpdateSimulation

  uri = path.Value[8:]
  with open(uri) as csv_file:
    next(csv_file) #Skip the first line
    csv_reader = csv.reader(csv_file, delimiter = ',')
    for row in csv_reader:
      Property_Name = str(row[0])
      Property_Type = str(row[1])
      if NewProperty_Type == 'Boolean':
        VCProperty_Type = VC_BOOLEAN
        Property_Value = str(row[2])
      if NewProperty_Type == 'String':
        VCProperty_Type = VC_STRING
        Property_Value = str(row[2])
      if NewProperty_Type == 'Integer':
        VCProperty_Type = VC_INTEGER
        Property_Value = int(row[2])
      if NewProperty_Type == 'Real':
        VCProperty_Type = VC_REAL
        Property_Value = float(row[2])
      Property_Rebuild = str(row[3])
      Property_UpdateSimulation = str(row[4])

def SimulationOnStartStop(sim, IsRunning):
  cmd.Enabled = True
  if IsRunning:
    cmd.Enabled = False
  else:
    cmd.Enabled = True

sim.OnStartStop = SimulationOnStartStop